import java.util.*;

public class BTree {

    static class Node {
        Node left,right;
        Comparable data;
        public Node(Comparable o, Node l, Node r){
            left = l;
            right = r;
            data = o;
        }
    }

    Node root = null;

    public BTree (){
    }

    public void insert(Comparable c){
        root = insert(c,root);
    }

    public boolean exists(Comparable c){
        return exists(c,root);
    }


    // insert object c into tree t.
    private static Node insert(Comparable c,Node t){
        if(t == null)
            return new Node(c,null,null);
        if(c.compareTo(t.data) < 0){
            t.left = insert(c,t.left);
        }else{
            t.right = insert(c,t.right);
        }
        return t;
    }

    private static boolean exists(Comparable c,Node t){
        if(t == null)
            return false;
        if(c.compareTo(t.data) == 0)
            return true;
        return exists(c,t.left) || exists(c,t.right);
    }

    protected static void intrav(Node t,Vector v){
        if(t == null)
            return;
        intrav(t.left,v);
        v.add(t.data);
        intrav(t.right,v);
    }

    public String toString(){
        Vector v = new Vector();
        intrav(root,v);
        String s = "[";
        for(int i=0;i<v.size()-1;i++){
            s += ""+v.elementAt(i)+", ";
        }
        return s+v.lastElement()+"]";
    }

    public static void main(String[] args){
        BTree bt = new BTree();

        for(int i=0;i<20;i++){
            bt.insert((int)(Math.random()*100));
        }
        
        System.out.println("tree is: "+bt);
        
    }
}

